/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
  Feature_AtLeastM68020Bit = 2,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->atLeastM68020())
    Features.set(Feature_AtLeastM68020Bit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Mximm8_1to8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Mximm16_1to8,
  GICXXPred_I64_Predicate_Mximm32_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("M68kInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool M68kInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("M68kInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(51), GIMT_Encode2(158), /*)*//*default:*//*Label 22*/ GIMT_Encode4(5544),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(438),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(657),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(939),
    /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1160),
    /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1456),
    /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1752),
    /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2186), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2620),
    /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(2839),
    /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(3058), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 10*/ GIMT_Encode4(3340),
    /*TargetOpcode::G_TRUNC*//*Label 11*/ GIMT_Encode4(3468),
    /*TargetOpcode::G_CONSTANT*//*Label 12*/ GIMT_Encode4(3506), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 13*/ GIMT_Encode4(3599), GIMT_Encode4(0),
    /*TargetOpcode::G_ZEXT*//*Label 14*/ GIMT_Encode4(3727),
    /*TargetOpcode::G_SHL*//*Label 15*/ GIMT_Encode4(3855),
    /*TargetOpcode::G_LSHR*//*Label 16*/ GIMT_Encode4(4086),
    /*TargetOpcode::G_ASHR*//*Label 17*/ GIMT_Encode4(4317), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ROTR*//*Label 18*/ GIMT_Encode4(4548),
    /*TargetOpcode::G_ROTL*//*Label 19*/ GIMT_Encode4(4779), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 20*/ GIMT_Encode4(5010),
    /*TargetOpcode::G_SMULH*//*Label 21*/ GIMT_Encode4(5277),
    // Label 0: @438
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 26*/ GIMT_Encode4(656),
    /*GILLT_s8*//*Label 23*/ GIMT_Encode4(461),
    /*GILLT_s16*//*Label 24*/ GIMT_Encode4(526),
    /*GILLT_s32*//*Label 25*/ GIMT_Encode4(591),
    // Label 23: @461
    GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(525),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28*/ GIMT_Encode4(506), // Rule ID 691 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 691,
        GIR_EraseRootFromParent_Done,
      // Label 28: @506
      GIM_Try, /*On fail goto*//*Label 29*/ GIMT_Encode4(524), // Rule ID 679 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 679,
        GIR_Done,
      // Label 29: @524
      GIM_Reject,
    // Label 27: @525
    GIM_Reject,
    // Label 24: @526
    GIM_Try, /*On fail goto*//*Label 30*/ GIMT_Encode4(590),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(571), // Rule ID 692 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 692,
        GIR_EraseRootFromParent_Done,
      // Label 31: @571
      GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(589), // Rule ID 680 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD16dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 680,
        GIR_Done,
      // Label 32: @589
      GIM_Reject,
    // Label 30: @590
    GIM_Reject,
    // Label 25: @591
    GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(636), // Rule ID 693 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 693,
        GIR_EraseRootFromParent_Done,
      // Label 34: @636
      GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(654), // Rule ID 681 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD32dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 681,
        GIR_Done,
      // Label 35: @654
      GIM_Reject,
    // Label 33: @655
    GIM_Reject,
    // Label 26: @656
    GIM_Reject,
    // Label 1: @657
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 39*/ GIMT_Encode4(938),
    /*GILLT_s8*//*Label 36*/ GIMT_Encode4(680),
    /*GILLT_s16*//*Label 37*/ GIMT_Encode4(766),
    /*GILLT_s32*//*Label 38*/ GIMT_Encode4(852),
    // Label 36: @680
    GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(765),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(716), // Rule ID 513 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG8d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 513,
        GIR_EraseRootFromParent_Done,
      // Label 41: @716
      GIM_Try, /*On fail goto*//*Label 42*/ GIMT_Encode4(746), // Rule ID 730 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 730,
        GIR_EraseRootFromParent_Done,
      // Label 42: @746
      GIM_Try, /*On fail goto*//*Label 43*/ GIMT_Encode4(764), // Rule ID 718 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 718,
        GIR_Done,
      // Label 43: @764
      GIM_Reject,
    // Label 40: @765
    GIM_Reject,
    // Label 37: @766
    GIM_Try, /*On fail goto*//*Label 44*/ GIMT_Encode4(851),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(802), // Rule ID 516 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG16d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 516,
        GIR_EraseRootFromParent_Done,
      // Label 45: @802
      GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(832), // Rule ID 731 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 731,
        GIR_EraseRootFromParent_Done,
      // Label 46: @832
      GIM_Try, /*On fail goto*//*Label 47*/ GIMT_Encode4(850), // Rule ID 719 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 719,
        GIR_Done,
      // Label 47: @850
      GIM_Reject,
    // Label 44: @851
    GIM_Reject,
    // Label 38: @852
    GIM_Try, /*On fail goto*//*Label 48*/ GIMT_Encode4(937),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 49*/ GIMT_Encode4(888), // Rule ID 519 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG32d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 519,
        GIR_EraseRootFromParent_Done,
      // Label 49: @888
      GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(918), // Rule ID 732 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 732,
        GIR_EraseRootFromParent_Done,
      // Label 50: @918
      GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(936), // Rule ID 720 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 720,
        GIR_Done,
      // Label 51: @936
      GIM_Reject,
    // Label 48: @937
    GIM_Reject,
    // Label 39: @938
    GIM_Reject,
    // Label 2: @939
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 54*/ GIMT_Encode4(1159),
    /*GILLT_s16*//*Label 52*/ GIMT_Encode4(958),
    /*GILLT_s32*//*Label 53*/ GIMT_Encode4(1130),
    // Label 52: @958
    GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1129),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1055), // Rule ID 670 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SMULd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 670,
        GIR_EraseRootFromParent_Done,
      // Label 56: @1055
      GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(1128), // Rule ID 666 //
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SMULd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 666,
        GIR_EraseRootFromParent_Done,
      // Label 57: @1128
      GIM_Reject,
    // Label 55: @1129
    GIM_Reject,
    // Label 53: @1130
    GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(1158), // Rule ID 669 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (mul:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (SMULd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SMULd32d32),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 669,
      GIR_Done,
    // Label 58: @1158
    GIM_Reject,
    // Label 54: @1159
    GIM_Reject,
    // Label 3: @1160
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 61*/ GIMT_Encode4(1455),
    /*GILLT_s8*//*Label 59*/ GIMT_Encode4(1179),
    /*GILLT_s16*//*Label 60*/ GIMT_Encode4(1283),
    // Label 59: @1179
    GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(1282), // Rule ID 650 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (sdiv:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVSXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::MOVSXd16d8),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 650,
      GIR_EraseRootFromParent_Done,
    // Label 62: @1282
    GIM_Reject,
    // Label 60: @1283
    GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(1454),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(1380), // Rule ID 662 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sdiv:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 662,
        GIR_EraseRootFromParent_Done,
      // Label 64: @1380
      GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1453), // Rule ID 654 //
        // (sdiv:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 654,
        GIR_EraseRootFromParent_Done,
      // Label 65: @1453
      GIM_Reject,
    // Label 63: @1454
    GIM_Reject,
    // Label 61: @1455
    GIM_Reject,
    // Label 4: @1456
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 68*/ GIMT_Encode4(1751),
    /*GILLT_s8*//*Label 66*/ GIMT_Encode4(1475),
    /*GILLT_s16*//*Label 67*/ GIMT_Encode4(1579),
    // Label 66: @1475
    GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(1578), // Rule ID 651 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (udiv:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVZXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::MOVZXd16d8),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 651,
      GIR_EraseRootFromParent_Done,
    // Label 69: @1578
    GIM_Reject,
    // Label 67: @1579
    GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(1750),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(1676), // Rule ID 663 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (udiv:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (UDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 663,
        GIR_EraseRootFromParent_Done,
      // Label 71: @1676
      GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1749), // Rule ID 655 //
        // (udiv:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 655,
        GIR_EraseRootFromParent_Done,
      // Label 72: @1749
      GIM_Reject,
    // Label 70: @1750
    GIM_Reject,
    // Label 68: @1751
    GIM_Reject,
    // Label 5: @1752
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 75*/ GIMT_Encode4(2185),
    /*GILLT_s8*//*Label 73*/ GIMT_Encode4(1771),
    /*GILLT_s16*//*Label 74*/ GIMT_Encode4(1921),
    // Label 73: @1771
    GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(1920), // Rule ID 652 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (srem:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVSXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(M68k::MOVSXd16d8),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/5, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 652,
      GIR_EraseRootFromParent_Done,
    // Label 76: @1920
    GIM_Reject,
    // Label 74: @1921
    GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(2184),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(2064), // Rule ID 664 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srem:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 664,
        GIR_EraseRootFromParent_Done,
      // Label 78: @2064
      GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(2183), // Rule ID 656 //
        // (srem:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 656,
        GIR_EraseRootFromParent_Done,
      // Label 79: @2183
      GIM_Reject,
    // Label 77: @2184
    GIM_Reject,
    // Label 75: @2185
    GIM_Reject,
    // Label 6: @2186
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 82*/ GIMT_Encode4(2619),
    /*GILLT_s8*//*Label 80*/ GIMT_Encode4(2205),
    /*GILLT_s16*//*Label 81*/ GIMT_Encode4(2355),
    // Label 80: @2205
    GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(2354), // Rule ID 653 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (urem:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVZXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(M68k::MOVZXd16d8),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/5, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 653,
      GIR_EraseRootFromParent_Done,
    // Label 83: @2354
    GIM_Reject,
    // Label 81: @2355
    GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(2618),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(2498), // Rule ID 665 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (urem:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 665,
        GIR_EraseRootFromParent_Done,
      // Label 85: @2498
      GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(2617), // Rule ID 657 //
        // (urem:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 657,
        GIR_EraseRootFromParent_Done,
      // Label 86: @2617
      GIM_Reject,
    // Label 84: @2618
    GIM_Reject,
    // Label 82: @2619
    GIM_Reject,
    // Label 7: @2620
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 90*/ GIMT_Encode4(2838),
    /*GILLT_s8*//*Label 87*/ GIMT_Encode4(2643),
    /*GILLT_s16*//*Label 88*/ GIMT_Encode4(2708),
    /*GILLT_s32*//*Label 89*/ GIMT_Encode4(2773),
    // Label 87: @2643
    GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(2707),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2688), // Rule ID 760 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 760,
        GIR_EraseRootFromParent_Done,
      // Label 92: @2688
      GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2706), // Rule ID 757 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 93: @2706
      GIM_Reject,
    // Label 91: @2707
    GIM_Reject,
    // Label 88: @2708
    GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2753), // Rule ID 761 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 761,
        GIR_EraseRootFromParent_Done,
      // Label 95: @2753
      GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2771), // Rule ID 758 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 96: @2771
      GIM_Reject,
    // Label 94: @2772
    GIM_Reject,
    // Label 89: @2773
    GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(2837),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(2818), // Rule ID 762 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 762,
        GIR_EraseRootFromParent_Done,
      // Label 98: @2818
      GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(2836), // Rule ID 759 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 99: @2836
      GIM_Reject,
    // Label 97: @2837
    GIM_Reject,
    // Label 90: @2838
    GIM_Reject,
    // Label 8: @2839
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 103*/ GIMT_Encode4(3057),
    /*GILLT_s8*//*Label 100*/ GIMT_Encode4(2862),
    /*GILLT_s16*//*Label 101*/ GIMT_Encode4(2927),
    /*GILLT_s32*//*Label 102*/ GIMT_Encode4(2992),
    // Label 100: @2862
    GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2926),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2907), // Rule ID 766 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 766,
        GIR_EraseRootFromParent_Done,
      // Label 105: @2907
      GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2925), // Rule ID 763 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 763,
        GIR_Done,
      // Label 106: @2925
      GIM_Reject,
    // Label 104: @2926
    GIM_Reject,
    // Label 101: @2927
    GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2991),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2972), // Rule ID 767 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 767,
        GIR_EraseRootFromParent_Done,
      // Label 108: @2972
      GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2990), // Rule ID 764 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 764,
        GIR_Done,
      // Label 109: @2990
      GIM_Reject,
    // Label 107: @2991
    GIM_Reject,
    // Label 102: @2992
    GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3056),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3037), // Rule ID 768 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 768,
        GIR_EraseRootFromParent_Done,
      // Label 111: @3037
      GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3055), // Rule ID 765 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 765,
        GIR_Done,
      // Label 112: @3055
      GIM_Reject,
    // Label 110: @3056
    GIM_Reject,
    // Label 103: @3057
    GIM_Reject,
    // Label 9: @3058
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 116*/ GIMT_Encode4(3339),
    /*GILLT_s8*//*Label 113*/ GIMT_Encode4(3081),
    /*GILLT_s16*//*Label 114*/ GIMT_Encode4(3167),
    /*GILLT_s32*//*Label 115*/ GIMT_Encode4(3253),
    // Label 113: @3081
    GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3166),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3117), // Rule ID 515 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (NOT8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT8d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 515,
        GIR_EraseRootFromParent_Done,
      // Label 118: @3117
      GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(3147), // Rule ID 772 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 772,
        GIR_EraseRootFromParent_Done,
      // Label 119: @3147
      GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(3165), // Rule ID 769 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 769,
        GIR_Done,
      // Label 120: @3165
      GIM_Reject,
    // Label 117: @3166
    GIM_Reject,
    // Label 114: @3167
    GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(3252),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(3203), // Rule ID 518 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (NOT16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT16d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 518,
        GIR_EraseRootFromParent_Done,
      // Label 122: @3203
      GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(3233), // Rule ID 773 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 773,
        GIR_EraseRootFromParent_Done,
      // Label 123: @3233
      GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(3251), // Rule ID 770 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 770,
        GIR_Done,
      // Label 124: @3251
      GIM_Reject,
    // Label 121: @3252
    GIM_Reject,
    // Label 115: @3253
    GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(3338),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(3289), // Rule ID 521 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (NOT32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT32d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 521,
        GIR_EraseRootFromParent_Done,
      // Label 126: @3289
      GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(3319), // Rule ID 774 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 774,
        GIR_EraseRootFromParent_Done,
      // Label 127: @3319
      GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(3337), // Rule ID 771 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 771,
        GIR_Done,
      // Label 128: @3337
      GIM_Reject,
    // Label 125: @3338
    GIM_Reject,
    // Label 116: @3339
    GIM_Reject,
    // Label 10: @3340
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 131*/ GIMT_Encode4(3467),
    /*GILLT_s16*//*Label 129*/ GIMT_Encode4(3359),
    /*GILLT_s32*//*Label 130*/ GIMT_Encode4(3416),
    // Label 129: @3359
    GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(3415), // Rule ID 615 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (anyext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 615,
      GIR_EraseRootFromParent_Done,
    // Label 132: @3415
    GIM_Reject,
    // Label 130: @3416
    GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(3441), // Rule ID 619 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 619,
      GIR_Done,
    // Label 133: @3441
    GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(3466), // Rule ID 623 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 623,
      GIR_Done,
    // Label 134: @3466
    GIM_Reject,
    // Label 131: @3467
    GIM_Reject,
    // Label 11: @3468
    GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(3505), // Rule ID 627 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::XR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::XR32RegClassID),
      // GIR_Coverage, 627,
      GIR_EraseRootFromParent_Done,
    // Label 135: @3505
    GIM_Reject,
    // Label 12: @3506
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 139*/ GIMT_Encode4(3598),
    /*GILLT_s8*//*Label 136*/ GIMT_Encode4(3529),
    /*GILLT_s16*//*Label 137*/ GIMT_Encode4(3552),
    /*GILLT_s32*//*Label 138*/ GIMT_Encode4(3575),
    // Label 136: @3529
    GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3551), // Rule ID 333 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOVI8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI8di),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 333,
      GIR_EraseRootFromParent_Done,
    // Label 140: @3551
    GIM_Reject,
    // Label 137: @3552
    GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(3574), // Rule ID 334 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOVI16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI16ri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 334,
      GIR_EraseRootFromParent_Done,
    // Label 141: @3574
    GIM_Reject,
    // Label 138: @3575
    GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3597), // Rule ID 335 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOVI32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI32ri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 335,
      GIR_EraseRootFromParent_Done,
    // Label 142: @3597
    GIM_Reject,
    // Label 139: @3598
    GIM_Reject,
    // Label 13: @3599
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 145*/ GIMT_Encode4(3726),
    /*GILLT_s16*//*Label 143*/ GIMT_Encode4(3618),
    /*GILLT_s32*//*Label 144*/ GIMT_Encode4(3675),
    // Label 143: @3618
    GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3674), // Rule ID 585 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (sext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 585,
      GIR_EraseRootFromParent_Done,
    // Label 146: @3674
    GIM_Reject,
    // Label 144: @3675
    GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3700), // Rule ID 590 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 590,
      GIR_Done,
    // Label 147: @3700
    GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3725), // Rule ID 595 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 595,
      GIR_Done,
    // Label 148: @3725
    GIM_Reject,
    // Label 145: @3726
    GIM_Reject,
    // Label 14: @3727
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 151*/ GIMT_Encode4(3854),
    /*GILLT_s16*//*Label 149*/ GIMT_Encode4(3746),
    /*GILLT_s32*//*Label 150*/ GIMT_Encode4(3803),
    // Label 149: @3746
    GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3802), // Rule ID 600 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (zext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 600,
      GIR_EraseRootFromParent_Done,
    // Label 152: @3802
    GIM_Reject,
    // Label 150: @3803
    GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3828), // Rule ID 605 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 605,
      GIR_Done,
    // Label 153: @3828
    GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3853), // Rule ID 610 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 610,
      GIR_Done,
    // Label 154: @3853
    GIM_Reject,
    // Label 151: @3854
    GIM_Reject,
    // Label 15: @3855
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 158*/ GIMT_Encode4(4085),
    /*GILLT_s8*//*Label 155*/ GIMT_Encode4(3878),
    /*GILLT_s16*//*Label 156*/ GIMT_Encode4(3947),
    /*GILLT_s32*//*Label 157*/ GIMT_Encode4(4016),
    // Label 155: @3878
    GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3946),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3927), // Rule ID 339 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 339,
        GIR_EraseRootFromParent_Done,
      // Label 160: @3927
      GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3945), // Rule ID 336 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 336,
        GIR_Done,
      // Label 161: @3945
      GIM_Reject,
    // Label 159: @3946
    GIM_Reject,
    // Label 156: @3947
    GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(4015),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3996), // Rule ID 340 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 340,
        GIR_EraseRootFromParent_Done,
      // Label 163: @3996
      GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(4014), // Rule ID 337 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 337,
        GIR_Done,
      // Label 164: @4014
      GIM_Reject,
    // Label 162: @4015
    GIM_Reject,
    // Label 157: @4016
    GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4084),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4065), // Rule ID 341 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 341,
        GIR_EraseRootFromParent_Done,
      // Label 166: @4065
      GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4083), // Rule ID 338 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 338,
        GIR_Done,
      // Label 167: @4083
      GIM_Reject,
    // Label 165: @4084
    GIM_Reject,
    // Label 158: @4085
    GIM_Reject,
    // Label 16: @4086
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 171*/ GIMT_Encode4(4316),
    /*GILLT_s8*//*Label 168*/ GIMT_Encode4(4109),
    /*GILLT_s16*//*Label 169*/ GIMT_Encode4(4178),
    /*GILLT_s32*//*Label 170*/ GIMT_Encode4(4247),
    // Label 168: @4109
    GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4177),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4158), // Rule ID 345 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 345,
        GIR_EraseRootFromParent_Done,
      // Label 173: @4158
      GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4176), // Rule ID 342 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 174: @4176
      GIM_Reject,
    // Label 172: @4177
    GIM_Reject,
    // Label 169: @4178
    GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4246),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4227), // Rule ID 346 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 346,
        GIR_EraseRootFromParent_Done,
      // Label 176: @4227
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4245), // Rule ID 343 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 177: @4245
      GIM_Reject,
    // Label 175: @4246
    GIM_Reject,
    // Label 170: @4247
    GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4315),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4296), // Rule ID 347 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 347,
        GIR_EraseRootFromParent_Done,
      // Label 179: @4296
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4314), // Rule ID 344 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 180: @4314
      GIM_Reject,
    // Label 178: @4315
    GIM_Reject,
    // Label 171: @4316
    GIM_Reject,
    // Label 17: @4317
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 184*/ GIMT_Encode4(4547),
    /*GILLT_s8*//*Label 181*/ GIMT_Encode4(4340),
    /*GILLT_s16*//*Label 182*/ GIMT_Encode4(4409),
    /*GILLT_s32*//*Label 183*/ GIMT_Encode4(4478),
    // Label 181: @4340
    GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4408),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4389), // Rule ID 351 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 351,
        GIR_EraseRootFromParent_Done,
      // Label 186: @4389
      GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(4407), // Rule ID 348 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 187: @4407
      GIM_Reject,
    // Label 185: @4408
    GIM_Reject,
    // Label 182: @4409
    GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4477),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4458), // Rule ID 352 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 352,
        GIR_EraseRootFromParent_Done,
      // Label 189: @4458
      GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(4476), // Rule ID 349 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 190: @4476
      GIM_Reject,
    // Label 188: @4477
    GIM_Reject,
    // Label 183: @4478
    GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(4546),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(4527), // Rule ID 353 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 353,
        GIR_EraseRootFromParent_Done,
      // Label 192: @4527
      GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(4545), // Rule ID 350 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 193: @4545
      GIM_Reject,
    // Label 191: @4546
    GIM_Reject,
    // Label 184: @4547
    GIM_Reject,
    // Label 18: @4548
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 197*/ GIMT_Encode4(4778),
    /*GILLT_s8*//*Label 194*/ GIMT_Encode4(4571),
    /*GILLT_s16*//*Label 195*/ GIMT_Encode4(4640),
    /*GILLT_s32*//*Label 196*/ GIMT_Encode4(4709),
    // Label 194: @4571
    GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4639),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4620), // Rule ID 363 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 363,
        GIR_EraseRootFromParent_Done,
      // Label 199: @4620
      GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4638), // Rule ID 360 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 200: @4638
      GIM_Reject,
    // Label 198: @4639
    GIM_Reject,
    // Label 195: @4640
    GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4708),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4689), // Rule ID 364 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 364,
        GIR_EraseRootFromParent_Done,
      // Label 202: @4689
      GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4707), // Rule ID 361 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 203: @4707
      GIM_Reject,
    // Label 201: @4708
    GIM_Reject,
    // Label 196: @4709
    GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4777),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4758), // Rule ID 365 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 365,
        GIR_EraseRootFromParent_Done,
      // Label 205: @4758
      GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4776), // Rule ID 362 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 206: @4776
      GIM_Reject,
    // Label 204: @4777
    GIM_Reject,
    // Label 197: @4778
    GIM_Reject,
    // Label 19: @4779
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 210*/ GIMT_Encode4(5009),
    /*GILLT_s8*//*Label 207*/ GIMT_Encode4(4802),
    /*GILLT_s16*//*Label 208*/ GIMT_Encode4(4871),
    /*GILLT_s32*//*Label 209*/ GIMT_Encode4(4940),
    // Label 207: @4802
    GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4870),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4851), // Rule ID 357 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 357,
        GIR_EraseRootFromParent_Done,
      // Label 212: @4851
      GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4869), // Rule ID 354 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 213: @4869
      GIM_Reject,
    // Label 211: @4870
    GIM_Reject,
    // Label 208: @4871
    GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4939),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4920), // Rule ID 358 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 358,
        GIR_EraseRootFromParent_Done,
      // Label 215: @4920
      GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4938), // Rule ID 355 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 216: @4938
      GIM_Reject,
    // Label 214: @4939
    GIM_Reject,
    // Label 209: @4940
    GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5008),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(4989), // Rule ID 359 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 359,
        GIR_EraseRootFromParent_Done,
      // Label 218: @4989
      GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5007), // Rule ID 356 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 219: @5007
      GIM_Reject,
    // Label 217: @5008
    GIM_Reject,
    // Label 210: @5009
    GIM_Reject,
    // Label 20: @5010
    GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5276),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5156), // Rule ID 672 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mulhu:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UMULd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 672,
        GIR_EraseRootFromParent_Done,
      // Label 221: @5156
      GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5275), // Rule ID 668 //
        // (mulhu:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UMULd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 668,
        GIR_EraseRootFromParent_Done,
      // Label 222: @5275
      GIM_Reject,
    // Label 220: @5276
    GIM_Reject,
    // Label 21: @5277
    GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5543),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(5423), // Rule ID 671 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mulhs:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SMULd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 671,
        GIR_EraseRootFromParent_Done,
      // Label 224: @5423
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(5542), // Rule ID 667 //
        // (mulhs:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SMULd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 667,
        GIR_EraseRootFromParent_Done,
      // Label 225: @5542
      GIM_Reject,
    // Label 223: @5543
    GIM_Reject,
    // Label 22: @5544
    GIM_Reject,
    }; // Size: 5545 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
